package webdb.sample.action;

import java.lang.reflect.InvocationTargetException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import webdb.sample.action.form.UserRegistrationForm;
import webdb.sample.entity.User;
import webdb.sample.logic.UserLogic;

public class RegisterAction extends Action {

    private UserLogic userLogic;

    public final ActionForward execute(ActionMapping mapping, ActionForm form,
            HttpServletRequest request, HttpServletResponse response)
            throws Exception {
        UserRegistrationForm userRegForm = (UserRegistrationForm) form;
        User user = createUser(userRegForm);
        userLogic.registerNewUser(user);
        request.setAttribute("user", user);
        return mapping.findForward("success");
    }

    private User createUser(UserRegistrationForm form)
            throws IllegalAccessException, InvocationTargetException {
        User user = new User();
        BeanUtils.copyProperties(user, form);
        return user;
    }

    public void setUserLogic(UserLogic userLogic) {
        this.userLogic = userLogic;
    }

}