package webdb.sample.dao.impl;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import webdb.sample.dao.UserDao;
import webdb.sample.entity.User;

public class MemoryUserDaoImpl implements UserDao {

    private int nextId;

    private Map userMap;

    /**
     * デフォルトコンストラクタ。
     */
    public MemoryUserDaoImpl() {
        super();
        nextId = 1;
        userMap = new HashMap();
    }

    /**
     * @see webdb.sample.user.dao.UserDao#getUserByEmail(java.lang.String)
     */
    public User getUserByEmail(String email) {
        for (Iterator itr = userMap.keySet().iterator(); itr.hasNext();) {
            Integer id = (Integer) itr.next();
            User user = (User) userMap.get(id);
            if (user.getEmail().equals(email)) {
                return user;
            }
        }
        return null;
    }

    /**
     * @see webdb.sample.user.dao.UserDao#insert(webdb.sample.user.entity.User)
     */
    public synchronized void insert(User user) {
        user.setId(nextId);
        userMap.put(new Integer(nextId), user);
        nextId++;
    }

    public void update(User user) {
        userMap.put(new Integer(user.getId()), user);
    }

    public User getUserByRandomKey(String key) {
        for (Iterator itr = userMap.keySet().iterator(); itr.hasNext();) {
            Integer id = (Integer) itr.next();
            User user = (User) userMap.get(id);
            if (user.getRandomKey() != null && user.getRandomKey().equals(key)) {
                return user;
            }
        }
        return null;
    }

}
