package webdb.sample.support.impl;

import org.apache.velocity.VelocityContext;

import webdb.sample.entity.User;
import webdb.sample.support.Mailer;

import com.ozacc.mail.Mail;
import com.ozacc.mail.SendMail;
import com.ozacc.mail.VelocityMailBuilder;

public class MailerImpl implements Mailer {

    private SendMail sendMail;

    private VelocityMailBuilder velocityMailBuilder;

    private String confirmationTemplatePath;

    private String completionTemplatePath;

    public void sendConfirmationMail(User user) {
        VelocityContext context = new VelocityContext();
        context.put("user", user);
        Mail mail = velocityMailBuilder.buildMail(confirmationTemplatePath,
                context);
        mail.addTo(user.getEmail(), user.getName());
        sendMail.send(mail);
    }

    public void sendCompletionMail(User user) {
        VelocityContext context = new VelocityContext();
        context.put("user", user);
        Mail mail = velocityMailBuilder.buildMail(completionTemplatePath,
                context);
        mail.addTo(user.getEmail(), user.getName());
        sendMail.send(mail);
    }

    public void setSendMail(SendMail sendMail) {
        this.sendMail = sendMail;
    }

    public void setVelocityMailBuilder(VelocityMailBuilder velocityMailBuilder) {
        this.velocityMailBuilder = velocityMailBuilder;
    }

    public void setConfirmationTemplatePath(String confirmationTemplatePath) {
        this.confirmationTemplatePath = confirmationTemplatePath;
    }

    public void setCompletionTemplatePath(String completionTemplatePath) {
        this.completionTemplatePath = completionTemplatePath;
    }

}
