package webdb.sample.support.impl;

import org.seasar.extension.unit.S2TestCase;

import webdb.sample.entity.User;

import com.ozacc.mail.Mail;
import com.ozacc.mail.MailBuilder;
import com.ozacc.mail.mock.MockSendMail;

public class MailerImplTest extends S2TestCase {

    private static final String PATH = "webdb/sample/mailer.dicon";

    private MailerImpl mailer;

    private MailBuilder mailBuilder;

    protected void setUp() throws Exception {
        include(PATH);
    }

    public void testSendConfirmationMail() throws Exception {
        User user = new User();
        user.setName("大塚知洋");
        user.setEmail("otsuka@example.com");
        user.setRandomKey("abcdefghijklmnopqrstuvwxyz");

        Mail expectedMail = mailBuilder
                .buildMail("/webdb/sample/support/impl/expected-confirmation.xml");

        MockSendMail mockSendMail = new MockSendMail();
        mockSendMail.setDebug(true);
        mockSendMail.addExpectedMail(expectedMail);
        mailer.setSendMail(mockSendMail);

        mailer.sendConfirmationMail(user);
        mockSendMail.verify();
    }

    public void testSendCompletionMail() {
        // 省略
    }

}
